import { PrismaClient } from '@prisma/client'
import { ChannelType, CommandContext, CommandOptionType, SlashCommand, SlashCreator } from 'slash-create'

export default class SetWelcomeChannelCommand extends SlashCommand {
  constructor(creator: SlashCreator) {
    super(creator, {
      name: 'set_welcome_channel',
      description: 'setwelcomechannel',
      options: [
        {
          name: 'channel',
          description: 'channel - blank to see current',
          type: CommandOptionType.CHANNEL,
          channel_types: [ChannelType.GUILD_TEXT]
        }
      ]
    })
  }

  async run(ctx: CommandContext) {
    const prisma = new PrismaClient()
    if (ctx.options.channel == null) {
      const gc = await prisma.guildConfig.findFirst({
        where: {
          id: ctx.guildID
        }
      })
      return `current welcomechannel is ${
        '<#' + gc.welcome_channel + '>' ?? 'none (use /set_welcome_channel #CHANNEL)'
      }`
    }
    await prisma.guildConfig.update({
      where: {
        id: ctx.guildID
      },
      data: {
        welcome_channel: ctx.options.channel
      }
    })
    return `set the welcomechannel to <#${ctx.options.channel}>`
  }
}
